<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch" label-width="90px">
      <el-form-item label="学生id" prop="studentId">
        <el-input v-model="queryParams.studentId" placeholder="请输入学生id" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item label="视频课时间" prop="videoTime">
        <el-input v-model="queryParams.videoTime" placeholder="请输入视频课时间" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item label="练题数" prop="questionCnt">
        <el-input v-model="queryParams.questionCnt" placeholder="请输入练题数" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item label="开始时间" prop="beginTime">
        <el-date-picker clearable v-model="queryParams.beginTime" type="date" value-format="YYYY-MM-DD"
          class="w-[170px]!" placeholder="请选择开始时间">
        </el-date-picker>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="Plus" @click="handleAdd"
          v-hasPermi="['learn:learnPlan:add']">新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="success" plain icon="Edit" :disabled="single" @click="handleUpdate"
          v-hasPermi="['learn:learnPlan:edit']">修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="danger" plain icon="Delete" :disabled="multiple" @click="handleDelete"
          v-hasPermi="['learn:learnPlan:remove']">删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="warning" plain icon="Download" @click="handleExport"
          v-hasPermi="['learn:learnPlan:export']">导出</el-button>
      </el-col>
      <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="learnPlanList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" fixed="left" />
      <!-- <el-table-column label="计划id" align="center" prop="id" /> -->
      <el-table-column label="学生id" align="center" prop="studentId" fixed="left" />
      <el-table-column label="视频课时间" align="center" prop="videoTime" />
      <el-table-column label="练题数" align="center" prop="questionCnt" />
      <el-table-column label="是否有效" align="center" prop="status" />
      <el-table-column label="开始时间" align="center" prop="beginTime" width="180">
        <template #default="scope">
          <span>{{ parseTime(scope.row.beginTime, '{y}-{m}-{d}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="统计情况" align="center" prop="stats" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width" min-width="140" fixed="right">
        <template #default="scope">
          <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)"
            v-hasPermi="['learn:learnPlan:edit']">修改</el-button>
          <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)"
            v-hasPermi="['learn:learnPlan:remove']">删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination v-show="total > 0" :total="total" v-model:page="queryParams.pageNum"
      v-model:limit="queryParams.pageSize" @pagination="getList" />

    <!-- 添加或修改学习计划对话框 -->
    <el-dialog :title="title" v-model="open" width="500px" append-to-body>
      <el-form ref="learnPlanRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="学生id" prop="studentId">
          <el-input v-model="form.studentId" placeholder="请输入学生id" />
        </el-form-item>
        <el-form-item label="视频课时间" prop="videoTime">
          <el-input v-model="form.videoTime" placeholder="请输入视频课时间" />
        </el-form-item>
        <el-form-item label="练题数" prop="questionCnt">
          <el-input v-model="form.questionCnt" placeholder="请输入练题数" />
        </el-form-item>
        <el-form-item label="开始时间" prop="beginTime">
          <el-date-picker clearable v-model="form.beginTime" type="date" value-format="YYYY-MM-DD"
            placeholder="请选择开始时间">
          </el-date-picker>
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="LearnPlan">
import { listLearnPlan, getLearnPlan, delLearnPlan, addLearnPlan, updateLearnPlan } from "@/api/learn/learnPlan"

const { proxy } = getCurrentInstance()

const learnPlanList = ref([])
const open = ref(false)
const loading = ref(true)
const showSearch = ref(true)
const ids = ref([])
const single = ref(true)
const multiple = ref(true)
const total = ref(0)
const title = ref("")

const data = reactive({
  form: {},
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    studentId: null,
    videoTime: null,
    questionCnt: null,
    status: null,
    beginTime: null,
    stats: null
  },
  rules: {
    studentId: [
      { required: true, message: "学生id不能为空", trigger: "blur" }
    ],
    videoTime: [
      { required: true, message: "视频课时间不能为空", trigger: "blur" }
    ],
    questionCnt: [
      { required: true, message: "练题数不能为空", trigger: "blur" }
    ],
    status: [
      { required: true, message: "是否有效不能为空", trigger: "change" }
    ],
  }
})

const { queryParams, form, rules } = toRefs(data)

/** 查询学习计划列表 */
function getList() {
  loading.value = true
  listLearnPlan(queryParams.value).then(response => {
    learnPlanList.value = response.rows
    total.value = response.total
    loading.value = false
  })
}

// 取消按钮
function cancel() {
  open.value = false
  reset()
}

// 表单重置
function reset() {
  form.value = {
    id: null,
    studentId: null,
    videoTime: null,
    questionCnt: null,
    status: null,
    beginTime: null,
    createTime: null,
    stats: null
  }
  proxy.resetForm("learnPlanRef")
}

/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNum = 1
  getList()
}

/** 重置按钮操作 */
function resetQuery() {
  proxy.resetForm("queryRef")
  handleQuery()
}

// 多选框选中数据
function handleSelectionChange(selection) {
  ids.value = selection.map(item => item.id)
  single.value = selection.length != 1
  multiple.value = !selection.length
}

/** 新增按钮操作 */
function handleAdd() {
  reset()
  open.value = true
  title.value = "添加学习计划"
}

/** 修改按钮操作 */
function handleUpdate(row) {
  reset()
  const _id = row.id || ids.value
  getLearnPlan(_id).then(response => {
    form.value = response.data
    open.value = true
    title.value = "修改学习计划"
  })
}

/** 提交按钮 */
function submitForm() {
  proxy.$refs["learnPlanRef"].validate(valid => {
    if (valid) {
      if (form.value.id != null) {
        updateLearnPlan(form.value).then(response => {
          proxy.$modal.msgSuccess("修改成功")
          open.value = false
          getList()
        })
      } else {
        addLearnPlan(form.value).then(response => {
          proxy.$modal.msgSuccess("新增成功")
          open.value = false
          getList()
        })
      }
    }
  })
}

/** 删除按钮操作 */
function handleDelete(row) {
  const _ids = row.id || ids.value
  proxy.$modal.confirm('是否确认删除学习计划编号为"' + _ids + '"的数据项？').then(function () {
    return delLearnPlan(_ids)
  }).then(() => {
    getList()
    proxy.$modal.msgSuccess("删除成功")
  }).catch(() => { })
}

/** 导出按钮操作 */
function handleExport() {
  proxy.download('learn/learnPlan/export', {
    ...queryParams.value
  }, `learnPlan_${new Date().getTime()}.xlsx`)
}

getList()
</script>
